/***************************************************************************
                          sdl_freetypetest.c  -  description
                             -------------------
    begin                : Fri Aug 31 2001
    copyright            : (C) 2001 by Ales Teska
    email                : teska@dbsystem.cz
 ***************************************************************************/

import SDL, SDL_freetype;
import std.random, std.date, std.c.stdlib, std.utf;

const char[] UNICODE_TEXT = "\000T\000h\000i\000s\000 \000t\000e\000x\000t\000 \000i\000s\000 \000i\000n\000 \000u\000n\000i\000c\000o\000d\000e\000 \000!\000!\000!\000\000\000\000\000\000";

int main()
 {
	char	*UnicodeText = UNICODE_TEXT;

	SDL_Surface	*Screen;
	SDL_Event	Event;
	int		starttime;
	int 		j,x,y;
	SDL_Surface	*BackGround;

	rand_seed(getUTCtime(), 0);

	if ((SDL_Init(SDL_INIT_VIDEO) == -1))
	 {
		printf("Couldn`t initialize SDL : %s", SDL_GetError());
		exit(-1);
	 }

	Screen = SDL_SetVideoMode(800,600,24,SDL_SWSURFACE);
	if (Screen == null)
	 {
		printf("Couldn`t set video mode : %s", SDL_GetError());
		SDL_Quit();
		exit(-1);
	 }


	if (SDL_InitFreeType() != 0)
	 {
		printf("%s\n",SDL_GetError());
		return(-1);
	 }

	//Initialized

	//Load back image ...
	BackGround = SDL_LoadBMP("back.bmp");
	SDL_BlitSurface(BackGround, null, Screen, null);

	/* SDL_DefaultFont does not work in Win32, global variable is not good? */
	SDL_FontParam font;
	font.Color.r = 255;
	font.Color.g = 255;
	font.Color.b = 255;
	font.Alpha = 255;
	font.Style = 0;
	font.FaceCache = null;
	font.FontChangeHistory = null;
	font.FaceDescr.Size = 14;
	font.FaceDescr.Index = 0;
	std.string.strcpy(font.FaceDescr.Name, "font.ttf");

	SDL_RenderTextASCII(Screen, 100, 130, "Test started !!!", &font, null);
	SDL_Flip(Screen);
	SDL_BlitSurface(BackGround, null, Screen, null);

	starttime = SDL_GetTicks();

//	font.Style = SDL_FTSTYLE_ITALIC;

	for (j = 0; j < 1; j++)
	{
		int i;

		for (y=0; y<600; y = y + 20)
		 {
			font.Alpha -= 8;
			for (x=0; x<800; x = x + 70)
			 {
				char buffer[16];		

				font.Color.r = y % 255;
				font.Color.g = x % 255;
				font.Color.b = (x*y) % 255;

				for (i = 0; i<5; i++) buffer[i] = std.random.rand() % 20 + 64;
				buffer[5] = 0;

	 			SDL_RenderTextASCII(Screen, x, y+15, buffer, &font, null);
			 }
		 }
	}

	printf("Time elapsed : %2.3f sec\n",(SDL_GetTicks() - starttime)/cast(double)1000);
	SDL_RenderTextASCII(Screen, 750, 585, SDL_FreeTypeGetVersion(), &font, null);

	SDL_Flip(Screen);

	//Keypress wait
	do {
		SDL_WaitEvent(&Event);
	} while (!((Event.type == SDL_KEYUP)&&(Event.key.keysym.sym == SDLK_ESCAPE)));


	font.Alpha = 255;
	font.Color.r = 255;
	font.Color.g = 255;
	font.Color.b = 255;

	SDL_RenderTextUNICODE(Screen, 100, 100, cast(Uint16 *)UnicodeText, &font, null);
	SDL_RenderTextASCII(Screen, 100, 130, "This text is in ASCII !!!", &font, null);
	SDL_RenderTextWIDE(Screen, 100, 160, cast(wchar[])"This text is in WIDE !!!", &font, null);

	SDL_GetTextSizeUNICODE(cast(Uint16 *)UnicodeText, &font, null, &x, &y, null, null, null, null, null);
	printf("Size of UNICODE box is : %d x %d\n", x, y);

	SDL_GetTextSizeASCII("This text is in ASCII !!!", &font, null, &x, &y, null, null, null, null, null);
	printf("Size of ASCII box is : %d x %d\n", x, y);

	SDL_RenderTextASCII(Screen, 100, 470, "BIG - \010\003\001\003\002\030This text is in ASCII and BIG !!!\010\200 and was BIG ...", &font, null);

	SDL_Flip(Screen);

	//Keypress wait
	do {
		SDL_WaitEvent(&Event);
	} while (!((Event.type == SDL_KEYUP)&&(Event.key.keysym.sym == SDLK_ESCAPE)));

	SDL_FreeSurface(BackGround);
	SDL_DoneFreeType();
	SDL_Quit();
	return(0);
 }
